; MazezaM by Ventzislav Tzvetkov
;         http://drhirudo.hit.bg
;  (c) 2003-2005
;
;Used some code by: Neviksti

;=== Include MemoryMap, VectorTable, HeaderInfo ===
.INCLUDE "MazezaM.inc"

;=== Include Library Routines & Macros ===
.INCLUDE "LoadGraphics.asm"
.INCLUDE "InitSNES.asm"
.INCLUDE "2input.asm"
.INCLUDE "Sprites.asm"
.INCLUDE "Strings.asm"


;For the first byte of Joypad.
;-----------------------------
.DEFINE JoyA      %10000000
.DEFINE JoyX      %01000000
.DEFINE JoyL      %00100000
.DEFINE JoyR      %00010000

;For the second byte of Joypad
;-----------------------------
.DEFINE JoyB      %10000000
.DEFINE JoyY      %01000000
.DEFINE JoySelect %00100000
.DEFINE JoyStart  %00010000
.DEFINE JoyUp     %00001000
.DEFINE JoyDown   %00000100
.DEFINE JoyLeft   %00000010
.DEFINE JoyRight  %00000001




;==============================================================================
; main
;==============================================================================

;Variables in the ZeroPage:

.DEFINE MapX		$18		;X Offset
.DEFINE MapY		$1A		;Y Offset - not used, except for Init.
.DEFINE CurrentFrame	(SpriteBuf1+sframe)	;Contains the Sprite number of Lancelot.
.DEFINE VideoBuffer     $0500
.DEFINE Screen		$90		;Pointer to the Screen spare memory.
.DEFINE LevelMap	$68		;Pointer to the memory where we store the Level Map.
.DEFINE	HTAB		$6A		;Horizontal position used in some routines.
.DEFINE VTAB		$6C		;Vertical position used in some routines.
.DEFINE RNDL		$6E		;PseudoRandom number (low byte).
.DEFINE LEVELBRICK	$50		;Keeps the Brick number for the DrawBricks routines.
.DEFINE HLP		$60		;Help cell.
.DEFINE LOOP		$62		;Working cell.
.DEFINE	MAZENO		$64		;Variable with the Level Number (MazazaM number).
.DEFINE	LIVES		$66		;Variable with the Lives left plus one.
.DEFINE DELIMO		$84		;Variable which will be divided in the division subroutine.
.DEFINE OSTATYK		$86		;Modulo of the Division DELIMO/DELITEL=DELIMO DELIMO%DELITE=OSTATYK
.DEFINE	DELITEL		$88		;Number for the Division.
.DEFINE WIDTH		$B6		;MazezaM Widht.
.DEFINE HEIGHT		$B8		;MazezaM Height.
.DEFINE LX		$BA		;Vertical Position of the Entrance. Starts from 0.
.DEFINE	RX		$BC		;Vertical Position of the Exit. Starts from 0.
.DEFINE	R		$BE		;How many Bricks to the Right. R=16-L-WIDTH.
.DEFINE I		$C4		;Work variable, used to store Lancelot's vertical position in the MazezaM.
.DEFINE L		$C6		;How many Bricks to the Right. L=((16-WIDTH)/2).
.DEFINE	T		$C8		;How many Rows of Bricks from the top to the Mazezam. T=((13-HEIGHT)/2).
.DEFINE	J		$CA		;Work variable, used to store Lancelot's horizontal position in the MazezaM.
.DEFINE SOUNDFLAG	$CC		;To detect if sounds is made, or if the Sound is on. Currently Unused.
.DEFINE SCPAGE		$CE		;ScreenPage. Points which from the both screens is in use. Binary variable.
.DEFINE LEVELPRT	$D0		;Pointer to the actual MazezaM in the ROM.
.DEFINE HLP2		$D2		;Another help cell.
.DEFINE HLP3		$D4		;Yet another helping cell.
.DEFINE BAR		$D6		;Number of the first tile of the bar in the MazezaM row - 4 different.
.DEFINE NAMEPTR		$E0		;Pointer to the MazazaM name.
.DEFINE MX		$F0		;Used to store Lancelot actual vertical position.
.DEFINE	NX		$F8		;Lancelot's last vertical position.
.DEFINE SX		$FA		;Lancelot's default for the MazezaM vertical position.
.DEFINE Moving		$C2		;A variable pointing if lancelot is moving.

.DEFINE FrameWait		$1C


.BANK 0 SLOT 0
.ORG 0
.SECTION "MazezaMCode"

Main:
	InitializeSNES		;Initialize the machine, clear the screen, set sprites, etc...

	rep #%00110000		;A/mem = 16 bit, X/Y=16bit


	LoadPalette	BG_Palette	;Load palette to make our game look correct.

;Title Screen and Level 1 drawing here.

	lda #1
	sta MAZENO
	sta SCPAGE		;The Level is drawn in the 2st screen (0=first, 1=second).
	lda #$0D00		;Initialize
	sta LevelMap		;The LevelMap pointer.
	lda #3			;Three
	sta LIVES		;Lves for a start.
	lda #10			;Ten is
	sta MX			;The default Lancelot's position.
	sta SX			;Remeber it for the Level one as well.
        jsr CLSscr1     	;Clear the first Screen.
        lda #$02		;Block from Level 2 for the title Screen.
	sta LEVELBRICK		;Set it for the Brick subroutines.
	ldy #$00		;At the TopLeft part of the Screen.
	jsr TwoBricks		;Draw two Bricks. Instead of LDX #2\n jsr Bricks.
	ldy #$1C		;At the Center
	jsr TwoBricks		;Another Two Bricks.
	ldy #$38		;At the TopRight
	jsr TwoBricks		;Another Two Bricks.
	ldy #128		;At the second row
	jsr TwoBricks		;Another Two Bricks.
	lda #128		;From the 128th tile
	ldy #136		;At the second row, third brick.
Url1:	sta (Screen),y		;Starts the URL graphics.
	inc a			;Next tile.
	iny			;At next position.
	iny			;Two times because of the attribute byte.		
	cmp #152		;Is it the last tile already?
	bne Url1		;No - continue to the upper part of the URL drawing.
	ldy #200		;The down part of the URL is here. 136 + (32 * 2).
Url2:	sta (Screen),y		;Place the next graphics.
	inc a			;Next tile.
	iny			;At next position.
	iny			;Word offset.
	cmp #176		;Is it the last bottom part tile already?
	bne Url2		;No - continue to the bottom part of the URL drawing.
	ldy #184		;To the Right of the URL
	jsr TwoBricks		;Draw Two Bricks.
	ldx #16			;A whole row here - 16 bricks.
	ldy #256		;Under the URL text.
	jsr Bricks		;Draw the Bricks.
	ldy #384		;Beneath
	jsr TwoBricks		;Another Two Bricks.
	ldy #440		;At the End of the row.
	jsr TwoBricks		;Another Two Bricks.
	lda #99			;From the 99th tile.
	ldy #468		;Under the full row of bricks.
Title1:	sta (Screen),y		;Draw the upper part of the Title.
	inc a			;Next tile.
	iny			;At the
	iny			;Next position.
	cmp #112		;Is it the last tile?
	bne Title1		;No - repeat the cycle.
	ldy #512		;Bottom part of the title, under the upper.
	jsr TwoBricks		;Two bricks because it's between two rows.
	lda #115		;From the 115th tile.
	ldy #532		;At the 532th position.
Title2:	sta (Screen),y		;Draw the bottom part of the Title graphic.
	inc a			;Go to the next tile.
	iny			;And move
	iny			;One word.
	cmp #128		;Check if it's the last tile.
	bne Title2		;If not - repeat the procedure.
	ldy #568		;After the Title.
	jsr TwoBricks		;Two more Bricks.
	ldy #640		;At the next row
	jsr TwoBricks		;Two Bricks again.
	lda #208		;From the 208th tile.
	ldy #714		;With 714 offset.
SbTxt1:	sta (Screen),y		;Draw the subtitle text.
	inc a			;Next tile.
	iny			;Next
	iny			;Word.
	cmp #230		;Is it the 230th tile already?
	bne SbTxt1		;No - repeat the cycle.
	ldy #842		;Offset for the second subtitle text.
SbTxt2	sta (Screen),y		;continues from the 230th tile.
	inc a			;Next tile.
	iny			;Next position.
	iny			;offset.
	cmp #252		;252th is the last tile.
	bne SbTxt2		;Not yet reached - repeat the cycle.
	ldy #696		;A long unrolled loop for drawing the walls.
	jsr TwoBricks		;With two bricks each.
	ldy #768
	jsr TwoBricks
	ldy #824
	jsr TwoBricks
	ldy #896
	jsr TwoBricks
	ldy #952
	jsr TwoBricks
	ldy #1024
	jsr TwoBricks
	ldy #1080
	jsr TwoBricks
	ldy #1152
	jsr TwoBricks
	ldy #1208
	jsr TwoBricks
	ldy #1280
	jsr TwoBricks
	ldy #1408
	ldx #16		;A whole Row at the bottom.
	jsr Bricks	; The speech routine here. Will add when finishing the game.
	jsr LEVEL	; Draw the first Level in the Spare page.
	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.

	;Copy stuff to the VRAM.
	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000
	LoadBlockToVRAM	BackgroundPics, $2000, $6000	; 384 tiles * (8bit color)= 0x6000 bytes
	LoadBlockToVRAM	ASCIITiles, $5000, $0800	;128 tiles * (2bit color = 2 planes) --> 2048 bytes
	LoadBlockToVRAM	SpriteTiles, $6000, $1000	;16 32x32 tiles * (4bit color = 4 planes) --> 8192 bytes

	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

	;Set the priority bit of all the BG2 tiles
	LDA #$80
	STA $2115		;set up the VRAM so we can write just to the high byte

	LDX #$0400		;32x32 tiles = 1024 = $400

Next_tile:
	STA $2119
	DEX
	BNE Next_tile
	
	JSR SpriteInit		;setup the sprite buffer
	JSR JoyInit		;setup joypads and enable NMI

	SetCursorPos 26,6
	PrintString "Press START to Begin"

	;setup the Lancelot sprite
	;put him in the center of the screen
	lda #($86-16) 		
	sta SpriteBuf1+sx
	lda #(175-16)
	sta SpriteBuf1+sy

	;put sprite #0 on screen
	lda #$54
	sta SpriteBuf2

	;set the sprite to the highest priority
	lda #$30			
	sta SpriteBuf1+spriority

	;setup the video modes and such, then turn on the screen
	JSR SetupVideo	

TitleLoop:		;Title Screen Loop

	inc RNDL	;Increment the pseudorandom cell.

	WAI

  	LDA Joy1 + 1
	ORA Joy2 + 1 

	BIT #JoyStart	;If Start Pressed - begin the game.

	beq TitleLoop	;Else do this forever. Will add more stuff later.

	SetCursorPos 26,6
	PrintString "                    "
	lda #96			;Initial sprite number.
	sta CurrentFrame	;Store it.

GBEGIN: WAI			;The Game begins here.
	WAI			;Wait two frames.
	lda SpriteBuf1+sx	;Check if it is time for scroll.
	cmp #224		;At the #224
	bcs GSCROL		;If yes - start scrolling.
	inc SpriteBuf1+sx	;Else move Lancelot.
	inc SpriteBuf1+sx	;By two positions.
	lda CurrentFrame	;Load the sprite number.
	cmp #100		;Check if it's 100.
	bne GBFrame		;If no continue.
	lda #93			;Else reset it - 93 + Carry + 2 = 96

GBFrame:
	adc #2			;Else add two to the sprite number. The carry is clear.
	sta CurrentFrame	;Set it as current sprite.
	bra GBEGIN		;Repeat.

GSCROL:				;The scroll subroutine starts here.
	lda #64			;64 times.
	sta HLP			;Use the HeLP cell.
	lda #4
	sta HLP2		;Second HeLP cell.
GSCROLLoop:
	WAI			;WAIt vertical Blank.
	dec HLP2		;Decrement the second help.
	bne GSCont		;
	lda #4
	sta HLP2
	inc SpriteBuf1+sx
	inc SpriteBuf1+sx	;The sprite advances.
GSCont:
	ldx MapX		;4 times each cycle - 64 * 4 = 256 - a whole screen.
	inx
	inx
	inx
	inx
	stx MapX		;Store the New value.
	dec SpriteBuf1+sx	;The sprite moves backwards as well.
	dec SpriteBuf1+sx
	dec SpriteBuf1+sx
	dec SpriteBuf1+sx
	lda CurrentFrame
	cmp #100
	bne GSFrame
;	clc
	lda #93
GSFrame:
	adc #2
	sta CurrentFrame

GSCROLDec:
	dec HLP
	bne GSCROLLoop

GameEnterLoop:
	lda SX
	sta MX
	cmp NX
	beq GameEnter
	bcc DownGo

UpGo:	lda #9		;Lancelot Goes up.
	sta HLP2
	lda #32
	sta CurrentFrame
UpGoLP:	WAI
	WAI
	dec HLP2
	bne UpGoCont
	lda #8
	sta HLP2
	dec MX
	lda MX
	cmp NX
	bne UpGoCont
	bra GameEnter

UpGoCont:
	dec SpriteBuf1+sy
	dec SpriteBuf1+sy
	lda CurrentFrame
	cmp #36
	bne UpGoFrame
	lda #29
;	clc
UpGoFrame
	adc #2
	sta CurrentFrame
	bra UpGoLP

DownGo:
	lda #9			;Lancelot Goes Down.
	sta HLP2		;9 - 1 steps = 8 * 2 pixels = 16
	lda #10			;The tenth sprite offset
	sta CurrentFrame	;Is for down.
DownGoLP:
	WAI			;Wait
	WAI			;Two frames.
	dec HLP2		;Decrement the remaing steps.
	bne DownGoCont		;If they reach zero:
	lda #8			;Reset
	sta HLP2		;The counter.
	inc MX			;Increment the Man Pos
	lda MX			;Compare it
	cmp NX			;With the Level Enter.
	beq GameEnter		;If equal - enter the Game.

DownGoCont:
	inc SpriteBuf1+sy	;Move the sprite
	inc SpriteBuf1+sy	;Two positions down.
	lda CurrentFrame	;Load the sprite number
	cmp #14			;If it is 4 - then
	bne AdDownB		;Reset it to Zero.
	lda #7			;The carry is set.
;	clc			;This is skipped.
AdDownB:	adc #2		;Add 2 numbers
	sta CurrentFrame	;To the sprite index.
	bra DownGoLP		;Return to the loop.

GameEnter:
	lda #9			;Lancelot Goes Right.
	sta HLP2		;And enters the MazezaM.
	stz HLP
	lda #96
	sta CurrentFrame
GameEnterLP:
	WAI
	WAI
	dec HLP2
	bne GameEnterCont
	lda #8
	sta HLP2
	inc HLP
	lda HLP
	cmp L
	bne GameEnterCont
	bra GameBegin

GameEnterCont:
	inc SpriteBuf1+sx
	inc SpriteBuf1+sx
	lda CurrentFrame
	cmp #100
	beq ResetGameEnterFrame
	adc #2			;The Carry is clear.
	sta CurrentFrame
	bra GameEnterLP

ResetGameEnterFrame:
	lda #96
	sta CurrentFrame
	bra GameEnterLP

GameBegin:
	rep #%00110000		;A/mem = 16bit, X/Y=16bit
	WAI
	WAI
	stz CurrentFrame
	lda NX			;Animation of the Door close.
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	sta HLP
	lda L
	dec a
	asl
	asl
	adc HLP
	sta HLP
	tay
	lda #51
	sta (Screen),y
	iny
	iny
	sta (Screen),y
	WAI
	WAI
	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000
	WAI
	WAI
	WAI
	WAI
	lda #8
	sta CurrentFrame	;He watches it.
	WAI
	WAI
	WAI
	WAI
	lda HLP
	adc #64
	tay
	lda #51
	sta (Screen),y
	iny
	iny
	sta (Screen),y
	WAI
	WAI
	WAI
	WAI
	WAI
	WAI
	WAI
	WAI
	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000
;	sep #%00100000  ;A/mem = 8 bit 
	stz Moving

GameLoop:		;Game Loop

	inc RNDL	;increment the pseudorandom cell.

	WAI		;WAIt for interrupt and then process the joystick.

	WAI

	inc Moving

	lda Moving
	cmp #25
	bne No25
	stz CurrentFrame

No25:	cmp #100
	bne No100
	lda #6
	sta CurrentFrame

No100:	cmp #150
	bne No150
	lda #8
	sta CurrentFrame

No150:	cmp #200
	bne No200
	lda #14
	sta CurrentFrame
No200:	cmp #250
	bne _up
	lda RNDL
	and #%00000010
	clc
	adc #2
	sta CurrentFrame
	stz Moving

	;See what buttons were pressed
_up:
	lda	Joy1+1
	and	#$08
	beq	_down

       ldx I
       dex
       bpl UpGo1         ;if (direction==UP && i>1)
UpPressRTSPK:
; jsr PUK
UpPressRTS:
	jmp GameLoop

UpGo1:  lda #0
	cpx #0
	beq UpGoMulCont

UpGoMul:
	clc
	adc WIDTH
	dex
	bne UpGoMul
UpGoMulCont:
	clc
	adc J
	dec a

	tay			;Transfer to Y and
	lda (LevelMap),y	;load the byte from there.
	and #$00FF		;Ignore the higher byte. (We are in 16 bit mode).
	cmp #' '		;Is it free space?
	bne UpPressRTSPK	;Yes it's free below - go down.

	dec I			;Increment the Lancelot vertical position.
UpGo5:
	lda #9			;Lancelot Goes Down.
	sta HLP2		;9 - 1 steps = 8 * 2 pixels = 16
	lda #32
	sta CurrentFrame	;The zero sprite is for down.
UpGoLoop:
	dec HLP2		;Decrement the remaing steps.
	bne UpGoLpCn		;If not zero - continue.
	brl _done		;If they reach zero - it's _done.

UpGoLpCn:
	dec SpriteBuf1+sy	;Move the sprite
	dec SpriteBuf1+sy	;Two positions up.
	WAI			;Wait
	WAI			;Two frames
	lda CurrentFrame	;Load the sprite number
	cmp #36			;If it is 4 - then
	bne AdUp		;Reset it to Zero.
	lda #29			;The carry is set.
;	clc			;This isn't needed. Saves one byte.
AdUp:	adc #2
	sta CurrentFrame
	bra UpGoLoop

_down:
	lda	Joy1+1
	and	#$04
	beq	_left

			;Joystick Down was pressed.

       ldx I
       inx
       cpx HEIGHT     ;if (direction==DOWN && i<H)
       bcc DownGo1
DownGoRTSPK:
   ;  jsr PUK			;No - return to the GameLoop
DownGoRTS:   jmp GameLoop
DownGo1:
	lda #0
DownGoMul:
	clc
	adc WIDTH
	dex
	bne DownGoMul
	clc
	adc J
	dec a

	tay			;Transfer to Y and
	lda (LevelMap),y	;load the byte from there.
	and #$00FF		;Ignore the higher byte. (We are in 16 bit mode).
	cmp #' '		;Is it free space?
	bne DownGoRTSPK		;Yes it's free below - go down.

	inc I			;Increment the Lancelot vertical position.
DownGo5:
	lda #9			;Lancelot Goes Down.
	sta HLP2		;9 - 1 steps = 8 * 2 pixels = 16
	lda #10
	sta CurrentFrame	;The zero sprite is for down.
DownGoLoop:
	dec HLP2		;Decrement the remaing steps.
	bne DownGoLPCNT		;If they reach zero - it's _done.
	brl _done

DownGoLPCNT:

	inc SpriteBuf1+sy	;Move the sprite
	inc SpriteBuf1+sy	;Two positions down.
	WAI			;Wait
	WAI			;Two frames
	lda CurrentFrame	;Load the sprite number
	cmp #14			;If it is 4 - then
	bne AdDown		;Reset it to Zero.
	lda #7			;The carry is set.
;	clc			;This is skipped.
AdDown:	adc #2
	sta CurrentFrame
	bra DownGoLoop

_left:
	lda	Joy1+1
	and	#$02
	beq	_right

LeftJoyP:
       ldy J
       cpy #2
       bcs LeftJoyCT
LeftGoRTSPK: ;jsr PUK
LeftJoyRTS:   jmp GameLoop

LeftJoyCT:		;else
	lda #0
	ldx I
;	dex
	beq Left0
LeftGoMul:
	clc
	adc WIDTH
	dex
	bne LeftGoMul
Left0:  sta HLP
	clc
	adc J
	dec a
	dec a

	tay			;Transfer to Y and
	lda (LevelMap),y	;load the byte from there.
	and #$00FF		;Ignore the higher byte. (We are in 16 bit mode).
	cmp #' '		;Is it free space?
	bne LeftSlideTest	;Yes it's free to the right - go Right.

	dec J			;Increment the Lancelot horizontal position.
LeftGo5:
	lda #9			;Lancelot Goes Down.
	sta HLP2		;9 - 1 steps = 8 * 2 pixels = 16
	lda #64
	sta CurrentFrame	;The zero sprite is for down.

LeftGoLoop:
	dec HLP2		;Decrement the remaing steps.
	beq LeftDone		;If they reach zero - it's _done.

	dec SpriteBuf1+sx	;Move the sprite
	dec SpriteBuf1+sx	;Two positions down.
	WAI			;Wait
	WAI			;Two frames
	lda CurrentFrame	;Load the sprite number
	cmp #68			;If it is 4 - then
	bne AdLeft		;Reset it to Zero.
	lda #61			;The carry is set.
;	clc			;This is skipped.
AdLeft: adc #2
	sta CurrentFrame
	bra LeftGoLoop

LeftSlideTest:
	lda HLP
	tay
	lda (LevelMap),y	;load the byte from there.
	and #$00FF		;Ignore the higher byte. (We are in 16 bit mode).
	cmp #' '		;Is it free space?
	bne LeftDone
	brl SlideLeft


LeftDone:
	bra	_done

_right:
	lda	Joy1+1
	and	#$01
	beq	NothingPressed

RightJoyP:
       ldy J
       cpy WIDTH
       beq RightJoyL
       bcc RightJoy1
RightJoyL:
     lda I       ;if (i==rx && j==w)
       cmp RX
       bne RightJoy1
	brl LevelCompl
RightJoy1:
     cpy WIDTH    ;if (j<WIDTH)
       bcc RightJoyCT
RightGoRTSPK:
 ;jsr PUK
RightJoyRTS:
	bra RightDone                ; exit

RightJoyCT:		;else
	lda #0
	ldx I
	beq Right0
RightGoMul:
	clc
	adc WIDTH
	dex
	bne RightGoMul
Right0:	sta HLP
	clc
	adc J

	tay			;Transfer to Y and
	lda (LevelMap),y	;load the byte from there.
	and #$00FF		;Ignore the higher byte. (We are in 16 bit mode).
	cmp #' '		;Is it free space?
	bne RightSlideTest	;Yes it's free to the right - go Right.

	inc J			;Increment the Lancelot horizontal position.
RightGo5:
	lda #9			;Lancelot Goes Down.
	sta HLP2		;9 - 1 steps = 8 * 2 pixels = 16
	lda #96
	sta CurrentFrame	;The zero sprite is for down.
RightGoLoop:
	dec HLP2		;Decrement the remaing steps.
	beq RightDone		;If they reach zero - it's _done.

	inc SpriteBuf1+sx	;Move the sprite
	inc SpriteBuf1+sx	;Two positions down.
	WAI			;Wait
	WAI			;Two frames
	lda CurrentFrame	;Load the sprite number
	cmp #100		;If it is 4 - then
	bne AdRight		;Reset it to Zero.
	lda #93			;The carry is set.
;	clc			;This is skipped.
AdRight: adc #2
	sta CurrentFrame
	bra RightGoLoop

RightSlideTest:
	lda HLP
	clc
	adc WIDTH
	dec a
	tay
	lda (LevelMap),y	;load the byte from there.
	and #$00FF		;Ignore the higher byte. (We are in 16 bit mode).
	cmp #' '		;Is it free space?
	bne RightDone
	brl SlideRight

RightDone:
	bra	_done

_done: stz Moving


NothingPressed:

  	LDA Joy1 + 1
	ORA Joy2 + 1 

	BIT #JoyA
	bne Reset
	
GLOP:	JMP GameLoop	;Do this forever

Reset:
 	LDA Joy1 + 1
	ORA Joy2 + 1 

	BIT #JoyY
	beq GLOP

	dec LIVES
	beq GameOver

	lda SCPAGE
	bne GoPAGE2
	inc SCPAGE

	bra SameLevel
GoPAGE2:
	stz SCPAGE

SameLevel:
	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.
	lda SX
	sta MX

	jsr LEVEL


	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.


	ldy #102

	ldx #5

VaitG:	WAI
	sty CurrentFrame
	WAI
	WAI
	WAI
	INY
	INY
	dex
	bne VaitG
	ldx #180

VaitG2: WAI
	dex
	bne VaitG2

	stz CurrentFrame

	stz SpriteBuf1+sx

	lda SX
	asl
	asl
	asl
	asl
	dec a
	sta SpriteBuf1+sy

	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000

	ldx #25

VaitG3: WAI
	dex
	bne VaitG3

	jmp GameEnterLoop

GameOver:

	rep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

	lda #658
	sta HLP
	lda #3
	sta HLP2

ErFGON:	ldx #7

ErFGO:	ldy HLP
	jsr EraseBrick
	inc HLP
	inc HLP
	inc HLP
	inc HLP
	dex
	bne ErFGO
	lda HLP
	clc
	adc #100
	sta HLP
	dec HLP2
	bne ErFGON

	ldy #116
	lda #198
	sta (Screen),y

	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000

	SetCursorPos 12,11
	PrintString "Game Over!"

	ldy #102

	ldx #5

VaitGF:	WAI
	sty CurrentFrame
	WAI
	WAI
	WAI
	INY
	INY
	dex
	bne VaitGF

VaitGOX:ldx #30

VaitGO:	WAI
  	LDA Joy1 + 1
	ORA Joy2 + 1 

	BIT #JoyStart	;If Start Pressed - restart the game.

	bne EndOfAll	;

	dex		;Else WAIt
	bne VaitGO
	dey
	bne VaitGOX
	ldx #180

EndOfAll:
	jmp Main

;==========================================================================================

.DEFINE FrameNum $12		

VBlank:
	rep #$30		;A/Mem=16bits, X/Y=16bits
	phb
	pha
	phx
	phy
	phd

	sep #$20		; mem/A = 8 bit, X/Y = 16 bit

	;*********transfer sprite data

	stz $2102		; set OAM address to 0
	stz $2103

	LDY #$0400
	STY $4300		; CPU -> PPU, auto increment, write 1 reg, $2104 (OAM data write)
	LDY #$0400
	STY $4302		; source offset
	LDY #$0220
	STY $4305		; number of bytes to transfer
	LDA #$7E
	STA $4304		; bank address = $7E  (work RAM)
	LDA #$01
	STA $420B		;start DMA transfer

	;*********transfer BG2 data
	LDA #$00
	STA $2115		;set up VRAM write to write only the lower byte

	LDX #$5800
	STX $2116		;set VRAM address to BG3 tile map

	LDY #$1800
	STY $4300		; CPU -> PPU, auto increment, write 1 reg, $2118 (Lowbyte of VRAM write)
	LDY #$0000
	STY $4302		; source offset
	LDY #$0400
	STY $4305		; number of bytes to transfer
	LDA #$7F
	STA $4304		; bank address = $7F  (work RAM)
	LDA #$01
	STA $420B		;start DMA transfer

	;update the map co-ordinates
	lda MapX
	sta $210D
	lda MapX+1
	sta $210D

	lda MapY
	sta $210E
	lda MapY+1
	sta $210E

	;update the joypad data
	JSR GetInput

	lda $4210		;clear NMI Flag

	REP #$30		;A/Mem=16bits, X/Y=16bits
	
	inc FrameNum

	PLD 
	PLY 
	PLX 
	PLA 
	PLB 
      RTI

;End of game Main code

;============================================================================
; SetupVideo -- Set the video mode for the game
;----------------------------------------------------------------------------
; In: None
;----------------------------------------------------------------------------
; Out: None
;----------------------------------------------------------------------------
SetupVideo:
	php

	rep #$10		;A/mem = 8bit, X/Y=16bit
	sep #$20

        lda #%01100011          ;Sprites 16x16
      sta $2101         

	lda #$04		;Set video mode 4, 8x8 tiles (256 color BG1, 4 color BG2)
      sta $2105         

	lda #%00000001		;Set BG1's Tile Map VRAM offset to $0000 (word address)
      sta $2107		;   and the Tile Map size to 64 tiles x 32 tiles

	lda #$52		;Set BG1's Character VRAM offset to $2000 (word address)
      sta $210B		;Set BG2's Character VRAM offset to $5000 (word address)

	lda #$58		;Set BG2's Tile Map VRAM offset to $5800 (word address)
      sta $2108		;   and the Tile Map size to 32 tiles x 32 tiles

	lda #$13		;Turn on BG1 and BG2 and Sprites
      sta $212C

      lda #$0F		;Turn on screen, full brightness
      sta $2100		

	lda #$FF		;Scroll BG2 down 1 pixel
	sta $2110
	sta $2110         

	plp
	rts
	rep #%00110000		;A/mem = 16bit, X/Y=16bit

CLSscr1:
	ldy #$1000
CLRS:	sty Screen
	ldy #$07FE
        lda #$00
CLR:	sta (Screen),y
	dey
	dey
	bpl CLR
	rts
CLSscr2:
	ldy #$1800		;Set the Screen pointer and the second screen an
	bne CLRS		;do the usual work.

TwoBricks: ldx #2

Bricks:   ;Draws Level (LEVELBRICK) X bricks at Y offset in the Memory.
	sty HTAB
Bricksl:
	lda LEVELBRICK		;LEVELBRICK contains the brick number.
	asl
	dec A  ;calculate the tile number - A*2-1
	ldy HTAB
	sta (Screen),y
	inc a			;Next tile.
	iny
	iny
	sta (Screen),y
	clc
	adc #19			;Add 19 to get the bottom tile.
	pha
	tya
	adc #62
	tay
	pla
	sta (Screen),y
	iny
	iny
	inc a			;Next tile.
	sta (Screen),y		;Save it.
	inc HTAB		;Increase the position.
	inc HTAB		;2 times.
	inc HTAB		;2 words.
	inc HTAB		;4 times total.
	dex			;Decrease the number of the bricks.
	bne Bricksl		;Are the more?
	rts			;No.

LEVEL:				;Level Drawing Subroutine. SCPAGE contains the Page number it should be drawn (0/1)
	lda SCPAGE
	bne PAGE2
	inc SCPAGE
	jsr CLSscr1
	bra TAKEV
PAGE2:	stz SCPAGE
	jsr CLSscr2

TAKEV:	lda MAZENO			;save the register (A - contains the level number).
	cmp #11
	bne NoComplete
	jmp GameComplete

NoComplete:
	sta LEVELBRICK
	asl				;*2 to get Word offset.
	tax				;transfer to X for indexing.

	lda.w LEVELSWIDTHTABLE-2,x	;Load Level Width
	sta.w WIDTH			;And Store it.

	lda.w LEVELSHEIGHTTABLE-2,x
	sta.w HEIGHT

	lda.w LXTABLE-2,x
	sta.w LX

	lda.w RXTABLE-2,x
	sta.w RX

	lda.w LEVELSTABLE-2,x
	sta.w LEVELPRT

	lda.w NAMESTABLE-2,x
	sta.w NAMEPTR
	lda #0
	ldx HEIGHT

Multiple:			;Multiply HEIGHT*WIDTH
	clc
	adc WIDTH
	dex
	bne Multiple
	tay
CPYLVL: lda (LEVELPRT),y	;Copy the Level from the ROM to the RAM, so we can manipulate the blocks.
	sta (LevelMap),y
	dey
	bpl CPYLVL
LVLPNT:	ldy #0
	jsr TwoBricks
	ldy #$1C
	jsr TwoBricks
	ldy #$38
	jsr TwoBricks
	lda #176
	ldy #90
	sta (Screen),y
	ldy #72
LVLTXT	sta (Screen),y
	inc a
	iny
	iny
	cmp #182
	bne LVLTXT
	iny
	iny
	lda MAZENO
	sta DELIMO
	ldx #10
	stx DELITEL
	jsr DIVISION
	clc
	lda DELIMO
	adc #182
	sta (Screen),y
	lda OSTATYK
	adc #182
	iny
	iny
	sta (Screen),y
	lda #192
	ldy #118
	sta (Screen),y
	ldy #100
LVSTXT:	sta (Screen),y
	inc a
	iny
	iny
	cmp #198
	bne LVSTXT
	iny
	iny
	lda LIVES
	sta DELIMO
	jsr DIVISION
	clc
	lda DELIMO
	adc #198
	sta (Screen),y
	lda OSTATYK
	adc #198
	iny
	iny
	sta (Screen),y
	lda #16			;l=((16-w)/2);t=((13-h)/2);r=16-l-w;
	sec
	sbc WIDTH
	lsr
	cmp #1
	bne STL
	inc a
STL:	sta L
	lda #13
	sbc HEIGHT
	lsr
	sta T
	lda #16
	sec
	sbc L
	sec
	sbc WIDTH
	sta R
	lda T
	sta HLP
	stz VTAB
	inc VTAB
	inc VTAB
BRUp:	lda HLP
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	tay
	ldx #16
	jsr Bricks
	dec HLP
	inc VTAB
	lda HLP
	bne BRUp
	sta LOOP
	dec VTAB
LDLOOP:	lda LOOP
	cmp LX
	bne LBRICKS
	lda VTAB
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	sta HLP
	bra RR
LBRICKS: LDX L
	lda VTAB
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	tay
	sta HLP	
	jsr Bricks
RR:	lda LOOP
	jsr RENDER
	lda LOOP
	cmp RX
	beq RRE
RBRICKS:
	lda WIDTH
	clc
	adc L
	asl
	asl
	clc
	adc HLP
	tay
	ldx R
	jsr Bricks
RRE:	inc LOOP
	inc VTAB
	lda LOOP
	cmp HEIGHT
	bne LDLOOP

BRDn:	lda VTAB
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	tay
	ldx #16
	jsr Bricks
	inc VTAB
	lda VTAB
	cmp #13
	bne BRDn
	ldy #0
	lda (NAMEPTR),y
	and #$00FF
	sta HLP
	lda #30
	sec
	sbc HLP
	lsr
	lsr
	tax
	stx HLP2
	lda VTAB
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	tay
	sta HLP3
	jsr Bricks
	lda HLP3
	clc
	adc #64
	sec
	sbc HLP2
	sec
	sbc HLP2
	sec
	sbc HLP2
	sec
	sbc HLP2
	tay
	ldx HLP2
	jsr Bricks
	lda HLP3
	clc
	adc HLP2
	adc HLP2
	adc HLP2
	adc HLP2
	adc #66
	sta HLP3
	ldy #0
	lda (NAMEPTR),y
	and #$00FF
	tax
	iny
	sty HLP2
	ldy HLP3
LVLNAME:
	sty HLP
	ldy HLP2
	
	lda (NAMEPTR),y
	and #$00FF
	clc
	adc #100
	ldy HLP
	sta (Screen),y
	inc HLP2
	iny
	iny
	dex
	bne LVLNAME

        lda #1
        sta J      ;i=lx;j=1
	lda LX
	sta I

	lda T
	clc
	adc LX
	inc a
	sta NX
	cmp MX
	bcc LNX
	bcs GNX
LNX:	jsr LessNX
	bra ENDCR
GNX	jsr GreatNX	

ENDCR:	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

	rts
	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.

RENDER:	adc RNDL
	sta DELIMO
	lda #4
	sta DELITEL
	jsr DIVISION
	lda OSTATYK
	and #%00000011
	cmp #0
	bne b2
	lda #67
b2:	cmp #1
	bne b3
	lda #70
b3:	cmp #2
	bne b4
	lda #73
b4:	cmp #3
	bne b5
	lda #76
b5:	sta BAR
	lda WIDTH
	sta HLP2
	dec HLP2
RenderIt:
	lda L
	clc
	adc HLP2
	asl
	asl
	clc
	adc HLP
	clc
	tax
	ldy HLP2
	lda LOOP
cmp0:	cmp #0
	beq LDP
	pha
	tya
	clc
	adc WIDTH
	tay
	pla
	dec a
	bra cmp0

LDP:
	lda (LEVELPRT),y
	txy
	and #$00FF
	cmp #'#'
	bne NoX
	jsr DrawBar
	bra NoZ
NoX:	cmp #'$'
	bne NoY
	jsr DrawLeftBar
	bra NoZ
	
NoY:	cmp #'&'
	bne NoM
	jsr DrawRightBar
	bra NoZ

NoM:	cmp #'%'
	bne NoZ
	jsr DrawMiddleBar
NoZ:
	iny
	iny
	iny
	iny
	dec HLP2
	bpl RenderIt
	rts


NAMESTABLE:
     .dw NAME1
     .dw NAME2
     .dw NAME3
     .dw NAME4
     .dw NAME5
     .dw NAME6
     .dw NAME7
     .dw NAME8
     .dw NAME9
     .dw NAMEA

             ;lenght
NAME1: .db 14,159,198,190,179,189,182,143,166,195,186,184,186,191,196 ;Humble Origins
NAME2: .db 14,156,178,196,202,143,143,155,192,182,196,143,143,160,197 ;Easy Does It
NAME3: .db 14,172,193,143,172,193,143,178,191,181,143,152,200,178,202 ;Up, Up  and Away
NAME4: .db 10,171,192,143,178,191,181,143,157,195,192 ;To and Fro
NAME5: .db 12,163,192,192,193,143,181,182,143,163,192,192,193 ;Loop de Loop
NAME6: .db 12,153,182,143,143,167,195,182,193,178,195,182,181 ;Be Prepared
NAME7: .db 16,171,200,192,143,143,157,195,192,191,197,143,155,192,192,195,196 ;Two  Front Doors
NAME8: .db 20,171,185,195,192,198,184,185,143,178,191,181,143,143,197,185,195,192,198,184,185 ;Through and  through
NAME9: .db 12,155,192,198,179,189,182,143,154,195,192,196,196 ;Double Cross
NAMEA: .db 10,160,191,196,186,181,182,143,166,198,197 ;Inside Out


LEVELSWIDTHTABLE:
     .dw 7,8,5,13,13,7,13,13,9,13

LEVELSHEIGHTTABLE:
     .dw 2,3,10,6,4,6,7,4,7,10

LXTABLE:
     .dw 0,2,9,0,1,4,0,2,6,7

RXTABLE:
     .dw 0,1,0,0,3,2,6,0,2,0


LEVEL1:
.db	" #  #  "
.db	" #  $& "

LEVEL2:
.db	"  #  $%&"
.db	"  # # # "
.db	" # # #  "

LEVEL3:
.db	"  #  "
.db	" # $&"
.db	" $&  "
.db	"# #  "
.db	" # # "
.db	" $&  "
.db	"# #  "
.db	" # # "
.db	" # # "
.db	" # $&"

LEVEL4:
.db	"   $%%%&     "
.db	"# $%%%&  $%& "
.db	" # $%& $%%&  "
.db	"# #  $%%%%%& "
.db	" $%& #   $&  "
.db	"# # # $&  #  "


LEVEL5:
.db	"  $%& $& $&  "
.db	"  $&  $&  $& "
.db	"$&  # $& $&  "
.db	"   $%%%%%&  #"


LEVEL6:
.db	"   #   "
.db	" $%%&  "
.db	" $%& $&"
.db	" # # # "
.db	" # $&  "
.db	"# $&   "


LEVEL7:
.db	"       $%&   "
.db	"  $%& $& # # "
.db	"$& $& $%& # #"
.db	"$&   # #     "
.db	"  $%%%%%%%%& "
.db	" # $&  # $&  "
.db	"  #  $%&   $&"


LEVEL8:
.db	" $%&  $%&  $&"
.db	" # # $& # #  "
.db	" # $& $& $&  "
.db	" # $&  $&  # "

LEVEL9:
.db	" #  $%%& "
.db	" #  # $& "
.db	" # $%%& #"
.db	"# $&  #  "
.db	"  #   $%&"
.db	" $%%%%&  "
.db	"  #      "


LEVELA:
.db	"           # "

;.db	" $%%%%%%%&  #"

.db	" $%&      $& "
.db	" # $%%%%& $& "
.db	" $& $&    $& "
.db	" $%&  #  $%& "
.db	" # $%%%%& $& "
.db	" # # #   $%& "
.db	" $%%%%%%%%&  "
.db	"             "

LEVELSTABLE:
     .dw LEVEL1
     .dw LEVEL2
     .dw LEVEL3
     .dw LEVEL4
     .dw LEVEL5
     .dw LEVEL6
     .dw LEVEL7
     .dw LEVEL8
     .dw LEVEL9
     .dw LEVELA

DIVISION:	;Division Subroutine. Modified for 16 bits Accumulator and 65816.

         ldx #16
         stz OSTATYK
CYCLE:   asl DELIMO
         rol OSTATYK
         sec
         lda OSTATYK
         sbc DELITEL
         BCC DECR
         sta OSTATYK
         inc DELIMO
DECR:    dex
         bne CYCLE
         rts


DrawBar:   ;Draws Level (LEVELBRICK) X bricks at Y offset in the Memory beggining at (Screen).
	lda BAR
	sta (Screen),y
	inc a			;Next tile.	
	inc a
	iny
	iny
	sta (Screen),y
	clc
	adc #14			;Add 19 to get the bottom tile.
	pha
	tya
	adc #62
	tay
	pla
	sta (Screen),y
	iny
	iny
	inc a			;Next tile.
	inc a
	sta (Screen),y		;Save it.
	rts			;End

DrawLeftBar:   ;Draws LeftBar (BAR number) Y offset in the Memory beginning at (Screen).
	lda BAR
	sta (Screen),y
	inc a			;Next tile.
	iny
	iny
	sta (Screen),y
	clc
	adc #15			;Add 19 to get the bottom tile.
	pha
	tya
	adc #62
	tay
	pla
	sta (Screen),y
	iny
	iny
	inc a			;Next tile.
	sta (Screen),y		;Save it.
	rts			;End

DrawRightBar: 			;Draws RightBar (BAR number) at Y offset in the Memory.
	lda BAR
	inc a
	sta (Screen),y
	inc a			;Next tile.
	iny
	iny
	sta (Screen),y
	clc
	adc #15			;Add 19 to get the bottom tile.
	pha
	tya
	adc #62
	tay
	pla
	sta (Screen),y
	iny
	iny
	inc a			;Next tile.
	sta (Screen),y		;Save it.
	rts			;End

DrawMiddleBar: 			;Draws MiddleBar (BAR number) at Y offset in the Memory.
	lda BAR
	inc a
	sta (Screen),y
	iny
	iny
	sta (Screen),y
	clc
	adc #16			;Add 19 to get the bottom tile.
	pha
	tya
	adc #62
	tay
	pla
	sta (Screen),y
	iny
	iny
	sta (Screen),y		;Draw it.
	rts			;End


LessNX:
	lda MX
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	tay
	jsr EraseBrick
	dec MX
	lda MX
	cmp NX
	bne LessNX
EndNX:	rts

GreatNX:lda MX
	cmp NX
	beq EndNX
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	tay
	jsr EraseBrick
	inc MX
	lda MX
	cmp NX
	bne GreatNX
	rts

EraseBrick:   ;Erases Bricks for tunnels.
	lda #0
	sta (Screen),y
	iny
	iny
	sta (Screen),y
	tya
	adc #62
	tay
	lda #0
	sta (Screen),y
	iny
	iny
	sta (Screen),y		;Erase once again.
	rts			;End


LevelCompl:
	inc LIVES
	lda I ;Print Yeah and complete the level!
	inc MAZENO

	lda #44
	sta CurrentFrame

	WAI

	rep #%00110000		;A/mem = 16 bit, X/Y=16bit

	lda I
	sec
	adc T
;	inc a
	sta MX
	sta SX
;	clc
;	lda L
;	adc J
;	asl
;	asl
;	sta HLP
;	lda MX
;	dec a
;	asl
;	asl
;	asl
;	asl
;	clc
;	adc HLP
;	sta Cursor
	sep #%00100000		;A/mem = 16 bit, X/Y=16bit
;	PrintString "Yeah!"	;Planned sound here.
	lda #46
	sta CurrentFrame

	WAI

;	tay
;	lda #52
;	sta (Screen),y
;	iny
;	iny
;	sta (Screen),y
	rep #%00110000		;A/mem = 16 bit, X/Y=16bit
	jsr LEVEL
	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.
	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000

	ldx #60
Vait:	WAI
	dex
	bpl Vait

	ldx #20
	lda #44
	sta CurrentFrame

Vait2:	WAI
	dex
	bpl Vait2
	lda #96
	sta CurrentFrame
	WAI
	jmp GBEGIN

SlideLeft:
	php
	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.
	lda HLP
	tay
	ldx WIDTH
	dex
SlideLeftLine:
	iny
	lda (LevelMap),y
	dey
	sta (LevelMap),y
	iny
	dex
	bne SlideLeftLine
	lda #' '
	sta (LevelMap),y
	dec J

	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.
	lda I
	sec
	adc T
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	sta HLP
	lda L
	asl
	asl
	adc HLP
	adc #2
	sta HLP

	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

SlideLeftGo:
	lda #8			;Lancelot Goes Left.
	sta HLP2		;8 steps * 2 pixels = 16
	lda #70
	sta CurrentFrame	;The zero sprite is for down.
SlideLeftLoop:

	dec SpriteBuf1+sx	;Move the sprite
	dec SpriteBuf1+sx	;Two positions down.
	WAI			;Wait
	WAI			;Two frames
	lda CurrentFrame	;Load the sprite number
	cmp #74			;If it is 4 - then
	bne AdSlideLeft		;Reset it to Zero.
	jsr SlideRealLeft
	lda #68			;The carry is set.
	clc			;This is skipped.
AdSlideLeft:
	adc #2
	sta CurrentFrame
	dec HLP2		;Decrement the remaing steps.
	bne SlideLeftLoop	;If they reach zero - it's _done.
	plp

	brl LeftDone



SlideRight:
	php
	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.
	lda HLP
	clc
	adc WIDTH
	dec a
	tay
	ldx WIDTH
	dex
SlideRightLine:
	dey
	lda (LevelMap),y
	iny
	sta (LevelMap),y
	dey
	dex
	bne SlideRightLine
	ldy HLP
	lda #' '
	sta (LevelMap),y
	inc J

	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.

	lda I
	sec
	adc T
	asl
	asl
	asl
	asl
	asl
	asl
	asl
	sta HLP
	lda L
	asl
	asl
	adc HLP
	sta HLP
	lda WIDTH
	dec a
	asl
	asl
	adc HLP
	sta HLP

	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

SlideRightGo:
	lda #8			;Lancelot Goes Down.
	sta HLP2		;Steps = 8 steps * 2 pixels = 16
	lda #38			;Pushing Right=38
	sta CurrentFrame	;The zero sprite is for down.
SlideRightLoop:

	inc SpriteBuf1+sx	;Move the sprite
	inc SpriteBuf1+sx	;Two positions down.
	WAI			;Wait
	WAI			;Two frames
	lda CurrentFrame	;Load the sprite number
	cmp #42			;If it is 4 - then
	bne AdSlideRight	;Reset it to Zero.
	jsr SlideRealRight
	lda #36			;The carry is set.
	clc			;This is skipped.
AdSlideRight:
	adc #2
	sta CurrentFrame
	dec HLP2		;Decrement the remaing steps.
	bne SlideRightLoop	;If they reach zero - it's _done.


	
	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.

	plp			;Restore P.
	brl RightDone

SlideRealLeft:
	php
	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.
	lda HLP
	tay
	lda WIDTH
	asl
	tax
	dex
	dex

SlideRealLeftLine1:
	iny
	iny
	lda (Screen),y
	dey
	dey
	sta (Screen),y
	iny
	iny
	iny
	iny
	lda (Screen),y
	dey
	dey
	sta (Screen),y
	dex
	bne SlideRealLeftLine1
	lda #0
	sta (Screen),y
	lda HLP
	clc
	adc #64
	tay
	lda WIDTH
	asl
	tax
	dex
	dex

SlideRealLeftLine2:
	iny
	iny
	lda (Screen),y
	dey
	dey
	sta (Screen),y
	iny
	iny
	iny
	iny
	lda (Screen),y
	dey
	dey
	sta (Screen),y
	dex
	bne SlideRealLeftLine2
	lda #0
	sta (Screen),y
	dec HLP
	dec HLP

	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000

	plp			;Restore P.
	rts

SlideRealRight:
	php
	rep #%00100000    ;A/mem = 16 bit. To not mess with the registers.
	lda HLP
	tay
	ldx WIDTH
	dex

SlideRealRightLine1:
	dey
	dey
	lda (Screen),y
	iny
	iny
	sta (Screen),y
	dey
	dey
	dey
	dey
	lda (Screen),y
	iny
	iny
	sta (Screen),y
	dey
	dey
	dex
	bne SlideRealRightLine1
	lda #0
	sta (Screen),y
	lda HLP
	clc
	adc #64
	tay
	ldx WIDTH
	dex

SlideRealRightLine2:
	dey
	dey
	lda (Screen),y
	iny
	iny
	sta (Screen),y
	dey
	dey
	dey
	dey
	lda (Screen),y
	iny
	iny
	sta (Screen),y
	dey
	dey
	dex
	bne SlideRealRightLine2
	lda #0
	sta (Screen),y
	inc HLP
	inc HLP
	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000
	plp
	rts

GameComplete:
	ldy #3
 	ldx #44
Hurray:	stx CurrentFrame
VaitE:	WAI
	dex
	bpl VaitE

	ldx #20
	lda #78
	sta CurrentFrame

VaitE2:	WAI
	dex
	bpl VaitE2
	ldx #46
	dey
	bne Hurray
			;Draw the End Screen.
        lda #$03	;Block from Level 2 for the title Screen.
	sta LEVELBRICK
	ldy #$10
	jsr TwoBricks	;Two Bricks at the up. Instead of LDX #2\n jsr Bricks
	lda #96
	sta CurrentFrame
	ldy #128
	ldx #6
	jsr Bricks
	lda #260
	sta HLP
	lda #8
	sta HLP2
Building:
	ldy HLP
	ldx #5
	jsr Bricks
	lda HLP
	clc
	adc #128
	sta HLP
	dec HLP2
	bne Building

	adc #124
	sta HLP
	lda #4
	sta HLP2
BuildingDown:
	ldy HLP
	ldx #6
	jsr Bricks
	lda HLP
	clc
	adc #128
	sta HLP
	dec HLP2
	bne BuildingDown

	ldy #$598
	sty HLP
	lda #84
	ldx #8
Bridge: sta (Screen),y
	iny
	iny
	dex
	bne Bridge
	lda #4
	sta HLP2
	lda #$618
	sta HLP
Water:	ldy HLP
	lda #47
	sta (Screen),y
	iny
	iny
	lda #64
	sta (Screen),y
	ldx #4
BtWater:
	tya
	adc #62
	tay
	lda #63
	sta (Screen),y
	iny
	iny
	sta (Screen),y
	dex
	bne BtWater
	lda HLP
	clc
	adc #4
	sta HLP
	dec HLP2
	bne Water

	lda #65
	sta BAR
	lda #$5A8
	sta HLP
	lda #6
	sta HLP2
	ldx #4
Ground:
	ldy HLP
	jsr DrawLeftBar
	ldx #4
BtGround:
	tya
	adc #62
	tay
	jsr DrawLeftBar
	dex
	bne BtGround
	
	lda HLP
	clc
	adc #4
	sta HLP
	dec HLP2
	bne Ground

	ldy #$566
	lda #52
	ldx #4
GrassF:	iny
	iny
	inc a
	sta (Screen),y
	dex
	bne GrassF

	ldy #$52C
	lda #48
	sta (Screen),y
	iny
	iny
	inc a
	sta (Screen),y

	iny
	iny
	lda #41
	sta BAR
	jsr DrawLeftBar
	inc BAR
	inc BAR
	ldy #$534
	jsr DrawLeftBar
	inc BAR
	ldy #$538
	jsr DrawRightBar

	iny
	iny
	lda #54
	sta (Screen),y
	iny
	iny
	sta (Screen),y

	ldy #$72
	lda #79
	sta (Screen),y
	lda #2
	sta HLP2
	lda #95
Cld:	ldx #3
Cloud:  iny
	iny
	inc a
	sta (Screen),y
	dex
	bne Cloud
	ldy #$B2
	lda #95
	sta (Screen),y
	lda #111
	dec HLP2
	bne Cld

	WAI
	LoadRAMBlockToVRAM	$1000, $0000, $1000	; 64x32 tiles = 2048 words = 4096 bytes = $1000

EndScroll:
	lda #64
	sta HLP
	lda #4
	sta HLP2
EndScrollLoop:
	WAI
	dec HLP2
	bne EndScrollCont
	lda #4
	sta HLP2
	inc SpriteBuf1+sx
	inc SpriteBuf1+sx
EndScrollCont:
	ldx	MapX
	inx
	inx
	inx
	inx
	stx	MapX
	dec SpriteBuf1+sx
	dec SpriteBuf1+sx
	dec SpriteBuf1+sx
	dec SpriteBuf1+sx
	lda CurrentFrame
	cmp #100
	bne EndScrollFrame
;	clc
	lda #93
EndScrollFrame:
	adc #2
	sta CurrentFrame

	dec HLP
	bne EndScrollLoop

	sep #%00100000    ;A/mem = 8 bit. To not mess with the registers.

	SetCursorPos 4,14
	PrintString "Congratulations"
	SetCursorPos 6,17
	PrintString "You have"
	SetCursorPos 7,17
	PrintString "escaped."
	SetCursorPos 10,16
	PrintString "WELL DONE!"

EndDownGo:
	lda #65			;Lancelot Goes Down.
	sta HLP2		;9 - 1 steps = 8 * 2 pixels = 16
	lda #10			;The tenth sprite offset
	sta CurrentFrame	;Is for down.
EndDownGoLP:
	WAI			;Wait
	WAI			;Two frames.
	dec HLP2		;Decrement the remaing steps.
	beq EndRightGo

EndDownGoCont:
	inc SpriteBuf1+sy	;Move the sprite
	inc SpriteBuf1+sy	;Two positions down.
	lda CurrentFrame	;Load the sprite number
	cmp #14			;If it is 4 - then
	bne EndAdDownB		;Reset it to Zero.
	lda #7			;The carry is set.
;	clc			;This is skipped.
EndAdDownB:	adc #2		;Add 2 numbers
	sta CurrentFrame	;To the sprite index.
	bra EndDownGoLP		;Return to the loop.

EndRightGo:
	lda #121		;Lancelot Goes Right - 121*2 = 242.
	sta HLP2
	stz HLP
	lda #96
	sta CurrentFrame
EndRightGoLP:
	WAI
	WAI
	dec HLP2
	beq End

	inc SpriteBuf1+sx
	inc SpriteBuf1+sx
	lda CurrentFrame
	cmp #100
	bne EndRightGoFrame
;	clc
	lda #93
EndRightGoFrame:
	adc #2
	sta CurrentFrame
	bra EndRightGoLP

End:
	stz CurrentFrame
	
Jam:	WAI
  	LDA Joy1 + 1
	ORA Joy2 + 1 

	BIT #JoyStart
	beq Jam

	jmp Main


.ENDS

;==========================================================================================

.BANK 1 SLOT 0
.ORG 0
.SECTION "CharacterData"

;Map data
BackgroundMap:
	.INCBIN "mymap.map"

;Color data
BG_Palette:
	.INCBIN "MazezaM.clr"	;Convert the picture with >pcx2snes MazezaM -n -s8 -c128 -o128
	.INCBIN "Lancelot.clr"

SpriteTiles:
	.INCBIN "Lancelot.pic"  ;Convert the sprite with >pcx2snes Lancelot -n -s8 -c16 -o128

ASCIITiles:
	.INCBIN "ascii.pic"

.ENDS

;==========================================================================================

.BANK 4 SLOT 0
.ORG 0
.SECTION "BG_CharacterData"

;character data
BackgroundPics:
	.INCBIN "MazezaM.pic"
.ENDS

;==========================================================================================
